(*** Programm zur Beseitigung von Kommentaren in PASCAL Quelltexten. ***)
(*** Einschraenkung: Es koennen keine geschachtelten Kommentare ver- ***)
(*** arbeitet  werden,  wie zum Beispiel  in  Turbo PASCAL  ueblich. ***)
(*** Allerdings werden Turbo PASCAL Compiler-Direktiven  erkannt und ***)
(*** nicht unterdrueckt  (Bsp.: {$I-U-A+} ).  Demzufolge kann dieses ***)
(*** Programm  nicht (!)  durch sich selbst  bearbeitet werden wegen ***)
(*** des Beispiels.    (Fuer Knobel-Fans: Was passiert, wenn doch ?) ***)
(*** (c) 23.01.1986,  Claus Schoenleber, Kiel; claus@schoenleber.com ***)

PROGRAM comment_killer (input,output,infile,outfile);

  CONST version   = '2.5';

  TYPE  file_name = STRING [14];

  VAR   infile,outfile            : text;
        characters,lines,ptext    : integer;
        filnam,result_file        : file_name;
        comment,pascal,apos,found : boolean;
        stack                     : ARRAY [1..3] OF char;
        switch                    : STRING [2];

PROCEDURE init_file (filename : file_name);
  VAR extension : boolean;
      point_pos : integer;
BEGIN
  point_pos := pos ('.',filename);
  extension := (point_pos <> 0);
  IF extension THEN
    result_file := concat (copy (filename,1,point_pos),'KIL')
  ELSE
  BEGIN
    result_file := concat (copy (filename,1,length (filename)),'.KIL');
    pascal := true
  END
END;   (*** of init_file ***)

PROCEDURE kill_comments;
BEGIN
  assign (outfile,result_file);
  rewrite (outfile);
  WHILE NOT eof (infile) DO
  BEGIN
    read (infile,stack [1]);
    characters := succ (characters);
    IF (stack [1] = ^M) THEN
      lines := succ (lines);
    (*** 'apos' entscheidet, ob Text oder Programm ***)
      IF (stack [1] = '''') AND NOT comment THEN
        apos := NOT apos;
    (*** Pruefen auf Kommentarbeginn ***)
      IF NOT apos AND NOT comment THEN
        comment := (stack [1] = '{')
                   OR ((stack [2] = '(') AND (stack [1] = '*'));
    (*** Compilerdirektiven nicht unterdruecken ***)
      IF (stack [1] = '$')
         AND
         ((stack [2] = '{') OR ((stack [3] = '(') AND (stack [2] = '*')))
         AND
         NOT apos THEN
      BEGIN
        comment := false;
        BEGIN
          CASE stack [2] OF
            '*' : BEGIN
                    CASE switch [2] OF
                      'C','c' : write (con,'(*');
                      'L','l' : write (lst,'(*')
                    END;
                    write (outfile,'(*')
                  END;
            '{' : BEGIN
                    CASE switch [2] OF
                      'C','c' : write (con,'{');
                      'L','l' : write (lst,'{')
                    END;
                    write (outfile,'{')
                  END
          END
        END
      END;
    (*** Programmtext schreiben. War '(' kein Komm., dann auch. ***)
      IF NOT comment THEN
      BEGIN
        IF (stack [2] = '(') THEN
        BEGIN
          CASE switch [2] OF
            'C','c' : write (con,stack [2]);
            'L','l' : write (lst,stack [2])
          END;
          write (outfile,stack [2])
        END;
        IF (stack [1] <> '(') THEN
        BEGIN
          ptext := succ (ptext);
          CASE switch [2] OF
            'C','c' : write (con,stack [1]);
            'L','l' : write (lst,stack [1])
          END;
          write (outfile,stack [1])
        END
      END;
    (*** Pruefen auf Kommentarende ***)
      IF comment AND NOT apos THEN
        comment := NOT (((stack [2] = '*') AND (stack [1] = ')'))
                   OR (stack [1] = '}'));
    (*** push (neues Zeichen) ***)
      stack [3] := stack [2];
      stack [2] := stack [1]
  END;
  close (infile);
  close (outfile)
END;

PROCEDURE init;
BEGIN
  filnam := '';
  switch := '';
  characters := 0;
  ptext := 0;
  lines := 0;
  pascal := false;
  apos := false;
  comment := false;
  stack [2] := ^M;
  stack [3] := ^A;
END;

PROCEDURE dialog;
  VAR sw_pos : integer;
BEGIN
  writeln;
  writeln ('   cKILL  V',version);
  writeln ('   Comment  Killer');
  writeln ('(c) 1/86 by C.Schoenleber, Kiel');
  writeln;
  filnam := paramstr (1);
  switch := paramstr (2);
  IF (filnam = '') THEN
  BEGIN
    write ('*');
    readln (filnam);
    IF (filnam <> '') THEN
    BEGIN
      sw_pos := pos('$',filnam);
      IF (sw_pos > 0) THEN
      BEGIN
        switch := copy (filnam,sw_pos,2);
        filnam := copy (filnam,1,length (filnam) - 3)
      END
    END
  END;
  IF (filnam <> '') THEN
  BEGIN
    init_file (filnam);
    IF pascal THEN
      assign (infile,filnam + '.PAS')
    ELSE
      assign (infile,filnam);
    {$I-}
    reset (infile);
    {$I+}
    found := (ioresult = 0);
    IF found THEN
      kill_comments
    ELSE
      writeln ('+++ aborted, File not found')
  END;
  writeln;
  IF (filnam <> '') AND found THEN
  BEGIN
    writeln;
    writeln ('[',lines:4,' ',characters:5,' ',ptext:5,']');
    writeln ('%completed')
  END;
  writeln ('%See you next time!')
END;

(* MAIN *)

BEGIN
  init;
  dialog
END.