(* Prettyprint
 *
 * Diese Programm verwandelt einen PASCAL-Quelltext in ein "schn" geschriebenes 
 * Programm, indem es alle reservierten Worte gro schreibt, alle anderen dagegen 
 * klein. Der Quelltextdateiname wird eingeben, die Ausgabedatei heit "L.OUT".
 *)

PROGRAM pp;
  CONST max = 47;
        blank = ' ';
        token : ARRAY [1..max] OF STRING [14] = ('implementation','interface','procedure',
                                                 'absolute','external','function',
                                                 'forward','overlay','program',
                                                 'downto','inline','packed',
                                                 'record','repeat','string',
                                                 'array','begin','const',
                                                 'label','until','while',
                                                 'uses','case','else',
                                                 'file','goto','then',
                                                 'type','with','and',
                                                 'div','end','for',
                                                 'mod','nil','not',
                                                 'set','shl','shr',
                                                 'var','xor','do',
                                                 'if','in','of',
                                                 'or','to');
  TYPE str = STRING;
  
  VAR infile,outfile : text;
      filename,line  : str;

PROCEDURE lower_case (VAR _s : str);
  VAR i : integer;
BEGIN
  FOR i := 1 TO length (_s) DO
    IF (_s [i] IN ['A'..'Z']) THEN
      _s [i] := chr (ord (_s [i]) + 32);
END; (*** of lower_case ***)

PROCEDURE upper_case (VAR _s : str);
  VAR i : integer;
BEGIN
  FOR i := 1 TO length (_s) DO
    _s [i] := upcase (_s [i]);
END; (*** of upper_case ***)

PROCEDURE token_search (_s : str; VAR _token : str; VAR _p : integer);
  VAR l   : integer;
      eol : boolean;
BEGIN
  _token := '';
  l := length (_s);
  WHILE (_s [_p] = blank) AND (_p <= l) DO
    _p := succ (_p);
  REPEAT
    _token := _token + _s [_p];
    _p :=succ (_p);
    eol := (_p > l);
  UNTIL (_s [_p] = blank) OR eol;
END; (*** of token_search ***)

PROCEDURE token_control (_word : str; VAR _is_token : boolean);
  VAR i : integer;
      c : STRING [1];
BEGIN
  _is_token := false;
  IF (pos (';',_word) > 0) OR (pos ('.',_word) > 0) THEN
  BEGIN
    c := copy (_word,length (_word),1);
    _word := copy (_word,1,length (_word) - 1);
  END;
  i := 1;
  REPEAT
    _is_token := (_word = token [i]);
    i := succ (i);
  UNTIL (i > max) OR _is_token;
  _word := _word + c;
END; (*** token_control ***)

PROCEDURE search_line (VAR _s : str);
  VAR j,p,l       : integer;
      t           : str;
      token_found : boolean;
BEGIN
  p := 0;
  l := length (_s);
  REPEAT
    p := succ (p);
    token_found := false;
    token_search (_s,t,p);
    lower_case (t);
    token_control (t,token_found);
    IF token_found THEN
      upper_case (t);
    delete (_s,p - length (t),length (t));
    insert (t,_s,p - length (t));
  UNTIL (p > length (_s));
END; (*** of search_line ***)

PROCEDURE do_it (VAR _infile,_outfile : text);
  VAR line : str;
BEGIN
  WHILE NOT eof (_infile) DO
  BEGIN
    readln (_infile,line);
    IF (length (line) > 0) THEN
      search_line (line);
    writeln (_outfile,line);
  END;
  close (_infile);
  close (_outfile);
END; (*** of do_it ***)

(*** $MAIN: pp ***)

BEGIN
  write ('Eingabedatei: ');
  readln (filename);
  assign (infile,filename);
  reset (infile);
  assign (outfile,'l.out');
  rewrite (outfile);
  do_it (infile,outfile);
END.
